<?php

namespace App\Console\Commands;

use App\Services\gRPC\Pinger\PingerInterface;
use App\Services\PingerService;
use Illuminate\Console\Command;
use Spiral\RoadRunner\GRPC\Invoker;
use Spiral\RoadRunner\GRPC\Server;
use Spiral\RoadRunner\Worker;

class Works extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'app:works';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = '启动 gRPC 服务';

    /**
     * Execute the console command.
     */
    public function handle()
    {
        $server = new Server(new Invoker(), [
            'debug' => false,
        ]);

        $server->registerService(PingerInterface::class, new PingerService());

        $server->serve(Worker::create());
    }
}
